
function DrawMainWin()

	wMainWin = Turbine.UI.Lotro.Window();
	wMainWin:SetSize(500,350);
	wMainWin:SetPosition(SETTINGS.MAINWIN.X,SETTINGS.MAINWIN.Y);
	wMainWin:SetText(PLUGINNAME);
	wMainWin:SetVisible(SETTINGS.MAINWIN.VISIBLE);
	wMainWin:SetHideF12(true);
	wMainWin:SetCloseEsc(true);
	wMainWin:AssignToDesktopIcon(true);

	local imgBack = Turbine.UI.Control();
	imgBack:SetParent(wMainWin);
	imgBack:SetSize(498,345);
	imgBack:SetPosition(1,3);
	imgBack:SetBackground(_IMAGES[1]);
	imgBack:SetMouseVisible(false);
	imgBack:SetBlendMode(4); --4

	Utils.Onscreen(wMainWin);

	-- Currency Drop Down + Label
	ddCurrency = Utils.DropDown(_CURRENCY,_CURRENCY[SETTINGS.CURRENCY]);
	ddCurrency:SetParent(wMainWin);
	ddCurrency:SetPosition(30,50);
	ddCurrency:SetWidth(80);
	ddCurrency:SetLabel(GetString(6));
	ddCurrency.ItemChanged = function (Sender,Args)
		SETTINGS.CURRENCY = Args.Index;
	end

	-- Points Text Box + Label
	txtCurPoints = NewWindowTextBox(wMainWin,80,20,30,90,SETTINGS.POINTS);
	txtCurPoints:SetLabel(GetString(4));
	txtCurPoints:SetToolTip(GetString(15));
	function curPointsUpdate()
		SETTINGS.POINTS = tonumber(txtCurPoints:GetText());
		txtCurPoints:SetText(SETTINGS.POINTS);
	end
	RegisterEditEvent(txtCurPoints,curPointsUpdate); -- make sure only numbers entered

	-- Double Bonus Points Check Box + Label
	chkDoubleBonus = Turbine.UI.Lotro.CheckBox();
	chkDoubleBonus:SetParent(wMainWin);
	chkDoubleBonus:SetSize(20,20);
	chkDoubleBonus:SetText("");
	chkDoubleBonus:SetPosition(275,50);
	chkDoubleBonus:SetChecked(SETTINGS.DBLPOINTS);
	chkDoubleBonus:SetLabel(GetString(5),"Right");
	chkDoubleBonus:SetToolTip(GetString(14));
	chkDoubleBonus.CheckedChanged = function()
		SETTINGS.DBLPOINTS = chkDoubleBonus:IsChecked();
	end

	-- Mithril Coin inspector
	cMithrilCoin = NewItemInfo(1879255991); -- 1879255991 = Mithril Coin item code
	cMithrilCoin:SetParent(wMainWin);
	cMithrilCoin:SetPosition(chkDoubleBonus:GetLeft()-5,77); -- 36x36

	-- Points/Mithril Coin Drop Down + Label
	ddPointType = Utils.DropDown(_STORECURRENCY);
	ddPointType:SetParent(wMainWin);
	ddPointType:SetPosition(30,152);
	ddPointType:SetWidth(140);
	ddPointType:SetLabel(GetString(7));
	ddPointType.ItemChanged = function (Sender,Args)
		--SETTINGS.CURRENCY = Args.Index;
	end

	-- Sore Item Cost Text Box + Label
	txtItemCost = NewWindowTextBox(wMainWin,80,20,ddPointType:GetLeft()+ddPointType:GetWidth()+10,152,"0");
	--txtItemCost:SetLabel(GetString(7));
	txtItemCost:SetToolTip(GetString(16));
	function storeCostUpdate()
		local cost = tonumber(txtItemCost:GetText());
		txtItemCost:SetText(cost);
	end
	RegisterEditEvent(txtItemCost,storeCostUpdate); -- make sure only numbers entered

	-- Calculate Button
	btnCalculate = NewWindowButton(wMainWin,GetString(8),90,txtItemCost:GetLeft()+txtItemCost:GetWidth()+20,152);
	btnCalculate.Click = function()
		UpdateCost();
	end;

	-- Result Labels
	lblNeeded = NewWindowLabel(wMainWin,440,20,30,215,"");
	lblNeeded:SetToolTip(GetString(17));
	lblPackage = NewWindowLabel(wMainWin,290,20,30,240,"");
	lblPackage:SetToolTip(GetString(18));
	lblCost = NewWindowLabel(wMainWin,290,25,280,280,"");
	lblCost:SetToolTip(GetString(20));
	lblCost:SetFont(_FONTS[4]);
	lblCost:SetForeColor(Turbine.UI.Color.Yellow);
	lblAdjustedCost = NewWindowLabel(wMainWin,290,25,30,280,"");
	lblAdjustedCost:SetToolTip(GetString(19));
	lblAdjustedCost:SetFont(_FONTS[4]);
	lblAdjustedCost:SetForeColor(Turbine.UI.Color.Yellow);

	-- Window events
	wMainWin.PositionChanged = function()
		SETTINGS.MAINWIN.X = wMainWin:GetLeft();
		SETTINGS.MAINWIN.Y = wMainWin:GetTop();
	end

	wMainWin.VisibleChanged = function()
		SETTINGS.MAINWIN.VISIBLE = wMainWin:IsVisible();
	end

	InitiateWallet();

end


function GetPointsPackage(points)
	if points == nil then return 1 end;
	local doublePoints = SETTINGS.DBLPOINTS;
	local package = 1;

	for i=1, table.getn(_LOTROPOINTS[SETTINGS.CURRENCY]) do
		local basePoints = _LOTROPOINTS[SETTINGS.CURRENCY][i][1];
		local bonusPoints = 0;
		package = i;

		if doublePoints then
			bonusPoints = _LOTROPOINTS[SETTINGS.CURRENCY][i][3];
		else
			bonusPoints = _LOTROPOINTS[SETTINGS.CURRENCY][i][2];
		end

		if (basePoints + bonusPoints) > points then
			break;
		end

	end

	return package;
end


function GetPackagePoints(package)
	if package == nil then package = 1 end;
	local basePoints = _LOTROPOINTS[SETTINGS.CURRENCY][package][1];
	local bonusPoints = 0;

	if SETTINGS.DBLPOINTS then
		bonusPoints = _LOTROPOINTS[SETTINGS.CURRENCY][package][3];
	else
		bonusPoints = _LOTROPOINTS[SETTINGS.CURRENCY][package][2];
	end

	return basePoints + bonusPoints;
end


function GetPackageCost(packageNumber)
	if packageNumber == nil then packageNumber = 1 end;
	local cost = _LOTROPOINTS[SETTINGS.CURRENCY][packageNumber][4];
	return cost;
end


function GetItemCost(packageNumber,pointsCost)
	if packageNumber == nil then packageNumber = 1 end;
	if pointsCost == nil then return 0 end;
	local relPackagePoints = GetPackagePoints(packageNumber);
	local relPackageCost = GetPackageCost(packageNumber);
	local relCostPoint = relPackageCost/relPackagePoints;
	return relCostPoint*pointsCost;
end


function GetVIPMonths(pointsNeeded)
	if pointsNeeded == nil or pointsNeeded <= 0 then return 0 end;
	return math.ceil(pointsNeeded/VIPPOINTS);
end


function GetMithrilPackage(coinCost)
	if coinCost == nil then coinCost = 0 end;
	-- checks which package is needed for the number of coins
	-- Based on closest package to overall cost, rather than the number of coins actually needed
	local package = 1;
	for i = 1, table.getn(_MITHRILCOINS) do
		package = i;
		if coinCost <= _MITHRILCOINS[i][1] then
			break;
		end
	end
	return package;
end


function GetMithrilCost(packageNumber)
	if packageNumber == nil then packageNumber = 1 end;
	local coinCost = 0;
	if _MITHRILCOINS[packageNumber] ~= nil then
		coinCost = _MITHRILCOINS[packageNumber][2];
	end
	return coinCost;
end


function GetMithrilPackageCoins(packageNumber)
	if packageNumber == nil then packageNumber = 1 end;
	local coins = 0;
	if _MITHRILCOINS[packageNumber] ~= nil then
		coins = _MITHRILCOINS[packageNumber][1];
	end
	return coins;
end





function UpdateCost()

	-- cost per point = price for package / total points from package
	-- relative cost of item = points cost * cost per point

	-- consider minimum points package needed to buy and the relative cost for that package
	-- How many months of VIP needed to save. VIPPOINTS = 500 (Points.lua);

	local storeBalance = txtCurPoints:GetText();
	if storeBalance == "" then storeBalance = 0 end;
	storeBalance = tonumber(storeBalance);

	local pointsCost = txtItemCost:GetText();
	if pointsCost == "" then pointsCost = 0 end;
	pointsCost = tonumber(pointsCost);

	local smallestPointsCost = 0;

	if pointsCost == 0 then return end; -- If no points cost then don't bother with the function

	local pointsNeeded = 0;


	-- If using Mithril Coins then an extra step is needed to translate the mithril cost into points
	if ddPointType:GetText() == _STORECURRENCY[2] then -- Mithril Coins

		-- lowest package for overall cost - assuming no coins already
		local coinPackage = GetMithrilPackage(pointsCost);
		local coinCost = GetMithrilCost(coinPackage);
		local pointsInPackage = GetMithrilPackageCoins(coinPackage);

		local pointsPerCoin = coinCost / pointsInPackage;


		-- lowest package for local cost, taking into account existing coins
		local coinsNeeded = pointsCost - MITHRILCOINS;
		if coinsNeeded < 0 then coinsNeeded = 0 end;

		Turbine.Shell.WriteLine("<rgb=#20B2AB><u>" .. PLUGINNAME .. ":</u></rgb>");

		print(_STRINGS[23].." "..coinsNeeded);

		local smallestCoins = GetMithrilPackage(coinsNeeded);
		local smallestPackageCoins = GetMithrilPackageCoins(smallestCoins);
		local smallestPackageCost = GetMithrilCost(smallestCoins);

		local smallestPointsPerCoin = smallestPackageCost / smallestPackageCoins;

		local numBundles = math.ceil(coinsNeeded / smallestPackageCoins);


		if coinsNeeded > 0 then
			print(_STRINGS[24].." "..numBundles.."x "..smallestPackageCoins.." ".._STRINGS[26].." ("..smallestPackageCost.." ".._STRINGS[25]..")");
			pointsNeeded = (numBundles*smallestPackageCost) - storeBalance;
		end

		print(_STRINGS[27].." " .. Utils.comma_value(pointsPerCoin * pointsCost));

		smallestPointsCost = smallestPointsPerCoin * pointsCost;
		pointsCost = pointsPerCoin * pointsCost;

	else

		pointsNeeded = pointsCost - storeBalance;

	end

	if pointsNeeded < 0 then pointsNeeded = 0 end;


	-- Find the cheapest points package needed for the number of points needed
	local cheapestPackage = 1;

	if pointsNeeded > 0 then

		lblNeeded:SetText(GetString(9) .. " " .. Utils.comma_value(pointsNeeded) .. "   (" .. GetString(21) .. " " .. GetVIPMonths(pointsNeeded) .. ")");

		cheapestPackage = GetPointsPackage(pointsNeeded);
		local packagePoints = GetPackagePoints(cheapestPackage);
		local packageCost = GetPackageCost(cheapestPackage);

		lblPackage:SetText(GetString(10) .. " " .. Utils.comma_value(packagePoints .. " - " .. _CURRENCY[SETTINGS.CURRENCY] .. " " .. string.format("%.2f",packageCost)));

		-- Calculate the package adjusted cost, this is based on the points the player already has and would need to buy to complete the purchase
		local adjustCost = 0;

		if ddPointType:GetText() == _STORECURRENCY[2] then
			adjustCost = GetItemCost(cheapestPackage,smallestPointsCost);
		else
			adjustCost = GetItemCost(cheapestPackage,pointsCost);
		end

		lblAdjustedCost:SetText(GetString(13) .. " " .. _CURRENCY[SETTINGS.CURRENCY] .. " " .. string.format("%.2f",adjustCost));

	else -- No points needed
		lblPackage:SetText(GetString(10) .. " " .. GetString(12));
		lblAdjustedCost:SetText(GetString(13) .. " " .. GetString(12));
		lblNeeded:SetText(GetString(9) .. " " .. Utils.comma_value(pointsNeeded));
	end


	-- Calculate the relative cost, this is based on the package needed if the player had no points at all
	local relPackageNum = GetPointsPackage(pointsCost);
	local itemCost = GetItemCost(relPackageNum,pointsCost);
	lblCost:SetText(GetString(11) .. " " .. _CURRENCY[SETTINGS.CURRENCY] .. " " .. string.format("%.2f",itemCost));

end



function InitiateWallet()

	GetMithrilCoins();

	-- Item added listener
	PLAYERWALLET.ItemAdded = function(sender, args)
		-- args.Index -- number: wallet index of the item
		-- args.Item  -- item: reference data for the item
		local curItem = args.Item;
		if curItem:GetName() == MITHRILNAME then
			MITHRILCOINS = curItem:GetQuantity();
			cMithrilCoin:SetQuantity(MITHRILCOINS);
			cMithrilCoin:SetEnabled(true);
			--print("Mithril added");
			curItem.QuantityChanged = function(sender,args)
				MITHRILCOINS = curItem:GetQuantity();
				cMithrilCoin:SetQuantity(MITHRILCOINS);
			end
		end
	end

	-- Item removed listener
	PLAYERWALLET.ItemRemoved = function(sender, args)
		-- args.Index -- number: wallet index of the item
		-- args.Item  -- item: reference data for the item
		local curItem = args.Item;
		if curItem:GetName() == MITHRILNAME then
			MITHRILCOINS = 0;
			cMithrilCoin:SetQuantity(MITHRILCOINS);
			cMithrilCoin:SetEnabled(false);
			--print("Mithril removed");
		end
	end

end


function GetMithrilCoins()

	MITHRILCOINS = 0;
	MITHRILNAME = GetLocalItemName(1879255991); -- 1879255991 = Mithril Coin

	for i=1, PLAYERWALLET:GetSize() do
		local walletItem = PLAYERWALLET:GetItem(i);
		if walletItem:GetName() == MITHRILNAME then -- change this string to look up item name in the language.
			walletItem.QuantityChanged = function(sender, args) -- Quantity Changed listener
				MITHRILCOINS = walletItem:GetQuantity();
				cMithrilCoin:SetQuantity(MITHRILCOINS);
			end
			MITHRILCOINS = walletItem:GetQuantity();
			break;
		end
	end

	cMithrilCoin:SetQuantity(MITHRILCOINS);
	if MITHRILCOINS == 0 then cMithrilCoin:SetEnabled(false) end;

end



function GetLocalItemName(itemID)

	if itemID == nil then return "" end;

	-- This function takes an Item ID, creates a reference for the item and returns the item name, which should be
	-- in the relevant language of the player. This will remove the need for item translations externally.
	local curItem = Utils.GetItemFromID(itemID);
	return curItem:GetItemInfo():GetName();

end

